Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90	(revision 2391)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90	(revision 2392)
@@ -4,4 +4,18 @@
    !! Ocean diagnostic variable : horizontal divergence and relative vorticity
    !!==============================================================================
+   !! History :  OPA  ! 1987-06  (P. Andrich, D. L Hostis)  Original code
+   !!            4.0  ! 1991-11  (G. Madec)
+   !!            6.0  ! 1993-03  (M. Guyon)  symetrical conditions
+   !!            7.0  ! 1996-01  (G. Madec)  s-coordinates
+   !!            8.0  ! 1997-06  (G. Madec)  lateral boundary cond., lbc
+   !!            8.1  ! 1997-08  (J.M. Molines)  Open boundaries
+   !!            8.2  ! 2000-03  (G. Madec)  no slip accurate
+   !!  NEMO      1.0  ! 2002-09  (G. Madec, E. Durand)  Free form, F90
+   !!             -   ! 2005-01  (J. Chanut) Unstructured open boundaries
+   !!             -   ! 2003-08  (G. Madec)  merged of cur and div, free form, F90
+   !!             -   ! 2005-01  (J. Chanut, A. Sellar) unstructured open boundaries
+   !!            3.3  ! 2010-09  (D.Storkey and E.O'Dea) bug fixes for BDY module
+   !!             -   ! 2010-10  (R. Furner, G. Madec) runoff and cla added directly here
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
@@ -9,18 +23,17 @@
    !!                vorticity fields
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
+   USE sbc_oce, ONLY : ln_rnf   ! surface boundary condition: ocean
+   USE sbcrnf          ! river runoff 
+   USE obc_oce         ! ocean lateral open boundary condition
+   USE cla             ! cross land advection             (cla_div routine)
    USE in_out_manager  ! I/O manager
-   USE obc_oce         ! ocean lateral open boundary condition
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE sbcrnf         ! river runoff 
-   USE sbc_oce, ONLY : ln_rnf   ! surface boundary condition: ocean
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC div_cur    ! routine called by step.F90 and istate.F90
+   PUBLIC   div_cur    ! routine called by step.F90 and istate.F90
 
    !! * Substitutions
@@ -30,7 +43,6 @@
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -48,13 +60,11 @@
       !!      vorticity at before and now time-step
       !!
-      !! ** Method  : 
-      !!      I.  divergence :
+      !! ** Method  : I.  divergence :
       !!         - save the divergence computed at the previous time-step
       !!      (note that the Asselin filter has not been applied on hdivb)
       !!         - compute the now divergence given by :
       !!         hdivn = 1/(e1t*e2t*e3t) ( di[e2u*e3u un] + dj[e1v*e3v vn] )
-      !!      above expression
-      !!         - apply lateral boundary conditions on hdivn 
-      !!      II. vorticity :
+      !!      correct hdiv with runoff inflow (div_rnf) and cross land flow (div_cla) 
+      !!              II. vorticity :
       !!         - save the curl computed at the previous time-step
       !!            rotb = rotn
@@ -62,6 +72,4 @@
       !!         - compute the now curl in tensorial formalism:
       !!            rotn = 1/(e1f*e2f) ( di[e2v vn] - dj[e1u un] )
-      !!         - apply lateral boundary conditions on rotn through a call
-      !!      of lbc_lnk routine.
       !!         - Coastal boundary condition: 'key_noslip_accurate' defined,
       !!      the no-slip boundary condition is computed using Schchepetkin
@@ -69,20 +77,11 @@
       !!      For example, along east coast, the one-sided finite difference
       !!      approximation used for di[v] is:
-      !!         di[e2v vn] =  1/(e1f*e2f)
-      !!                    * ( (e2v vn)(i) + (e2v vn)(i-1) + (e2v vn)(i-2) )
+      !!         di[e2v vn] =  1/(e1f*e2f) * ( (e2v vn)(i) + (e2v vn)(i-1) + (e2v vn)(i-2) )
       !!
       !! ** Action  : - update hdivb, hdivn, the before & now hor. divergence
       !!              - update rotb , rotn , the before & now rel. vorticity
-      !!
-      !! History :
-      !!   8.2  !  00-03  (G. Madec)  no slip accurate
-      !!   9.0  !  03-08  (G. Madec)  merged of cur and div, free form, F90
-      !!        !  05-01  (J. Chanut, A. Sellar) unstructured open boundaries
-      !! NEMO 3.3  !  2010-09  (D.Storkey and E.O'Dea) bug fixes for BDY module
-      !!----------------------------------------------------------------------
-      !! * Arguments
+      !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
-      
-      !! * Local declarations
+      !
       INTEGER ::   ji, jj, jk     ! dummy loop indices
       INTEGER ::   ii, ij, jl     ! temporary integer
@@ -102,8 +101,8 @@
       DO jk = 1, jpkm1                                 ! Horizontal slab
          !                                             ! ===============
-
+         !
          hdivb(:,:,jk) = hdivn(:,:,jk)    ! time swap of div arrays
          rotb (:,:,jk) = rotn (:,:,jk)    ! time swap of rot arrays
-
+         !
          !                                             ! --------
          ! Horizontal divergence                       !   div
@@ -198,6 +197,5 @@
             DO ji = 1, fs_jpim1   ! vector opt.
                rotn(ji,jj,jk) = (  zwv(ji+1,jj  ) - zwv(ji,jj)      &
-                                 - zwu(ji  ,jj+1) + zwu(ji,jj)  )   &
-                              * fmask(ji,jj,jk) / ( e1f(ji,jj)*e2f(ji,jj) )
+                  &              - zwu(ji  ,jj+1) + zwu(ji,jj)  ) * fmask(ji,jj,jk) / ( e1f(ji,jj)*e2f(ji,jj) )
             END DO
          END DO
@@ -228,16 +226,15 @@
                * ( -4. * zwu(ii,ij) + zwu(ii,ij-1) - 0.2 * zwu(ii,ij-2) )
          END DO
-
          !                                             ! ===============
       END DO                                           !   End of slab
       !                                                ! ===============
 
-      IF( ln_rnf )  CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
+      IF( ln_rnf      )   CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
+      IF( nn_cla == 1 )   CALL cla_div    ( kt )             ! Cross Land Advection (Update Hor. divergence)
       
       ! 4. Lateral boundary conditions on hdivn and rotn
       ! ---------------------------------=======---======
-      CALL lbc_lnk( hdivn, 'T', 1. )     ! T-point, no sign change
-      CALL lbc_lnk( rotn , 'F', 1. )     ! F-point, no sign change
-
+      CALL lbc_lnk( hdivn, 'T', 1. )   ;   CALL lbc_lnk( rotn , 'F', 1. )    ! lateral boundary cond. (no sign change)
+      !
    END SUBROUTINE div_cur
    
@@ -259,6 +256,5 @@
       !!      - compute the now divergence given by :
       !!         hdivn = 1/(e1t*e2t*e3t) ( di[e2u*e3u un] + dj[e1v*e3v vn] )
-      !!      above expression
-      !!      - apply lateral boundary conditions on hdivn 
+      !!      correct hdiv with runoff inflow (div_rnf) and cross land flow (div_cla) 
       !!              - Relavtive Vorticity :
       !!      - save the curl computed at the previous time-step (rotb = rotn)
@@ -266,6 +262,4 @@
       !!      - compute the now curl in tensorial formalism:
       !!            rotn = 1/(e1f*e2f) ( di[e2v vn] - dj[e1u un] )
-      !!      - apply lateral boundary conditions on rotn through a call to
-      !!      routine lbc_lnk routine.
       !!      Note: Coastal boundary condition: lateral friction set through
       !!      the value of fmask along the coast (see dommsk.F90) and shlat
@@ -274,19 +268,7 @@
       !! ** Action  : - update hdivb, hdivn, the before & now hor. divergence
       !!              - update rotb , rotn , the before & now rel. vorticity
-      !!
-      !! History :
-      !!   1.0  !  87-06  (P. Andrich, D. L Hostis)  Original code
-      !!   4.0  !  91-11  (G. Madec)
-      !!   6.0  !  93-03  (M. Guyon)  symetrical conditions
-      !!   7.0  !  96-01  (G. Madec)  s-coordinates
-      !!   8.0  !  97-06  (G. Madec)  lateral boundary cond., lbc
-      !!   8.1  !  97-08  (J.M. Molines)  Open boundaries
-      !!   9.0  !  02-09  (G. Madec, E. Durand)  Free form, F90
-      !!        !  05-01  (J. Chanut) Unstructured open boundaries
-      !!----------------------------------------------------------------------
-      !! * Arguments
+      !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-      
-      !! * Local declarations
+      !
       INTEGER  ::   ji, jj, jk          ! dummy loop indices
       REAL(wp) ::  zraur, zdep
@@ -302,8 +284,8 @@
       DO jk = 1, jpkm1                                 ! Horizontal slab
          !                                             ! ===============
-
+         !
          hdivb(:,:,jk) = hdivn(:,:,jk)    ! time swap of div arrays
          rotb (:,:,jk) = rotn (:,:,jk)    ! time swap of rot arrays
-
+         !
          !                                             ! --------
          ! Horizontal divergence                       !   div 
@@ -312,6 +294,6 @@
             DO ji = fs_2, fs_jpim1   ! vector opt.
                hdivn(ji,jj,jk) =   &
-                  (  e2u(ji,jj)*fse3u(ji,jj,jk) * un(ji,jj,jk) - e2u(ji-1,jj  )*fse3u(ji-1,jj  ,jk) * un(ji-1,jj  ,jk)       &
-                   + e1v(ji,jj)*fse3v(ji,jj,jk) * vn(ji,jj,jk) - e1v(ji  ,jj-1)*fse3v(ji  ,jj-1,jk) * vn(ji  ,jj-1,jk)  )    &
+                  (  e2u(ji,jj)*fse3u(ji,jj,jk) * un(ji,jj,jk) - e2u(ji-1,jj)*fse3u(ji-1,jj,jk) * un(ji-1,jj,jk)       &
+                   + e1v(ji,jj)*fse3v(ji,jj,jk) * vn(ji,jj,jk) - e1v(ji,jj-1)*fse3v(ji,jj-1,jk) * vn(ji,jj-1,jk)  )    &
                   / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
             END DO  
@@ -349,11 +331,11 @@
       !                                                ! ===============
 
-      IF( ln_rnf )  CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
+      IF( ln_rnf      )   CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
+      IF( nn_cla == 1 )   CALL cla_div    ( kt )             ! Cross Land Advection (update hdivn field)
 
       ! 4. Lateral boundary conditions on hdivn and rotn
       ! ---------------------------------=======---======
-      CALL lbc_lnk( hdivn, 'T', 1. )       ! T-point, no sign change
-      CALL lbc_lnk( rotn , 'F', 1. )       ! F-point, no sign change
-
+      CALL lbc_lnk( hdivn, 'T', 1. )   ;   CALL lbc_lnk( rotn , 'F', 1. )     ! lateral boundary cond. (no sign change)
+      !
    END SUBROUTINE div_cur
    
Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 2391)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 2392)
@@ -164,12 +164,10 @@
       !                        ! Control of timestep choice
       IF( lk_dynspg_ts .OR. lk_dynspg_exp ) THEN
-         IF( n_cla == 1 )   &
-           &   CALL ctl_stop( ' Crossland advection not implemented for this free surface formulation ' )
+         IF( nn_cla == 1 )   CALL ctl_stop( 'Crossland advection not implemented for this free surface formulation' )
       ENDIF
 
-      !                        ! Control of momentum forulation
+      !                        ! Control of momentum formulation
       IF( lk_dynspg_ts .AND. lk_vvl ) THEN
-         IF( .NOT. ln_dynadv_vec )   &
-           &   CALL ctl_stop( ' Flux formulae not implemented for this free surface formulation ' )
+         IF( .NOT.ln_dynadv_vec )   CALL ctl_stop( 'Flux form not implemented for this free surface formulation' )
       ENDIF
 
Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_flt.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 2391)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 2392)
@@ -39,5 +39,5 @@
    USE bdydyn          ! Unstructured open boundaries condition (bdy_dyn routine) 
    USE bdyvol          ! Unstructured open boundaries condition (bdy_vol routine)
-   USE cla_dynspg      ! cross land advection
+   USE cla             ! cross land advection
    USE in_out_manager  ! I/O manager
    USE lib_mpp         ! distributed memory computing library
@@ -199,7 +199,5 @@
       CALL Agrif_dyn( kt )    ! Update velocities on each coarse/fine interfaces 
 #endif
-#if defined key_orca_r2
-      IF( n_cla == 1 )   CALL dyn_spg_cla( kt )      ! Cross Land Advection (update (ua,va))
-#endif
+      IF( nn_cla == 1 )   CALL cla_dynspg( kt )      ! Cross Land Advection (update (ua,va))
 
       ! compute the next vertically averaged velocity (effect of the additional force not included)
Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 2391)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 2392)
@@ -19,5 +19,4 @@
    USE domvvl          ! Variable volume
    USE divcur          ! hor. divergence and curl      (div & cur routines)
-   USE cla_div         ! cross land: hor. divergence      (div_cla routine)
    USE iom             ! I/O library
    USE restart         ! only for lrst_oce
@@ -147,8 +146,6 @@
       ENDIF
       !
-
-                         CALL div_cur( kt )           ! Horizontal divergence & Relative vorticity
-      IF( n_cla == 1 )   CALL div_cla( kt )           ! Cross Land Advection (Update Hor. divergence)
-
+      CALL div_cur( kt )                              ! Horizontal divergence & Relative vorticity
+      !
       z2dt = 2. * rdt                                 ! set time step size (Euler/Leapfrog)
       IF( neuler == 0 .AND. kt == nit000 )   z2dt =rdt
Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90	(revision 2391)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90	(revision 2392)
@@ -21,4 +21,5 @@
    USE traadv_qck      ! QUICKEST scheme           (tra_adv_qck    routine)
    USE traadv_eiv      ! eddy induced velocity     (tra_adv_eiv    routine)
+   USE cla             ! cross land advection      (cla_traadv     routine)
    USE ldftra_oce      ! lateral diffusion coefficient on tracers
    USE in_out_manager  ! I/O manager
@@ -29,19 +30,18 @@
    PRIVATE
 
-   PUBLIC   tra_adv         ! routine called by step module
-   PUBLIC   tra_adv_init    ! routine called by opa module
+   PUBLIC   tra_adv        ! routine called by step module
+   PUBLIC   tra_adv_init   ! routine called by opa module
  
-   !                                                   !!* Namelist namtra_adv *
-   LOGICAL ::   ln_traadv_cen2   = .TRUE.       ! 2nd order centered scheme flag
-   LOGICAL ::   ln_traadv_tvd    = .FALSE.      ! TVD scheme flag
-   LOGICAL ::   ln_traadv_muscl  = .FALSE.      ! MUSCL scheme flag
-   LOGICAL ::   ln_traadv_muscl2 = .FALSE.      ! MUSCL2 scheme flag
-   LOGICAL ::   ln_traadv_ubs    = .FALSE.      ! UBS scheme flag
-   LOGICAL ::   ln_traadv_qck    = .FALSE.      ! QUICKEST scheme flag
+   !                                        !!* Namelist namtra_adv *
+   LOGICAL ::   ln_traadv_cen2   = .TRUE.    ! 2nd order centered scheme flag
+   LOGICAL ::   ln_traadv_tvd    = .FALSE.   ! TVD scheme flag
+   LOGICAL ::   ln_traadv_muscl  = .FALSE.   ! MUSCL scheme flag
+   LOGICAL ::   ln_traadv_muscl2 = .FALSE.   ! MUSCL2 scheme flag
+   LOGICAL ::   ln_traadv_ubs    = .FALSE.   ! UBS scheme flag
+   LOGICAL ::   ln_traadv_qck    = .FALSE.   ! QUICKEST scheme flag
 
    INTEGER ::   nadv   ! choice of the type of advection scheme
 
-   REAL(wp), DIMENSION(jpk) ::   r2dt  ! vertical profile time-step, = 2 rdttra
-      !                                ! except at nit000 (=rdttra) if neuler=0
+   REAL(wp), DIMENSION(jpk) ::   r2dt   ! vertical profile time-step, = 2 rdttra except at nit000 (=rdttra) if neuler=0
 
    !! * Substitutions
@@ -51,7 +51,6 @@
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -65,5 +64,5 @@
       !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
-      !!
+      !
       INTEGER ::   jk   ! dummy loop index
       REAL(wp), DIMENSION(jpi,jpj,jpk)   ::  zun, zvn, zwn   ! 3D workspace: effective transport
@@ -75,4 +74,7 @@
          r2dt(:) = 2. * rdttra(:)                      ! = 2 rdttra (leapfrog)
       ENDIF
+      !
+      IF( nn_cla == 1 )   CALL cla_traadv( kt )       !==  Cross Land Advection  ==! (hor. advection)
+      !
       !                                               !==  effective transport  ==!
       DO jk = 1, jpkm1
@@ -84,5 +86,5 @@
       !
       IF( lk_traldf_eiv .AND. .NOT. ln_traldf_grif )   &
-         &                  CALL tra_adv_eiv( kt, zun, zvn, zwn, 'TRA' )      ! add the eiv transport (if necessary)
+         &              CALL tra_adv_eiv( kt, zun, zvn, zwn, 'TRA' )          ! add the eiv transport (if necessary)
       !
       CALL iom_put( "uoce_eff", zun )                                         ! output effective transport      
@@ -97,5 +99,4 @@
       CASE ( 5 )   ;    CALL tra_adv_ubs   ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  UBS 
       CASE ( 6 )   ;    CALL tra_adv_qck   ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  QUICKEST 
-
       !
       CASE (-1 )                                      !==  esopa: test all possibility with control print  ==!
@@ -118,7 +119,6 @@
          CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' adv6 - Ta: ', mask1=tmask,               &
             &          tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         !
       END SELECT
-
+      !
       !                                              ! print mean trends (used for debugging)
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' adv  - Ta: ', mask1=tmask,               &
@@ -137,6 +137,6 @@
       INTEGER ::   ioptio
       !!
-      NAMELIST/namtra_adv/ ln_traadv_cen2 , ln_traadv_tvd,    &
-         &                 ln_traadv_muscl, ln_traadv_muscl2, &
+      NAMELIST/namtra_adv/ ln_traadv_cen2 , ln_traadv_tvd,     &
+         &                 ln_traadv_muscl, ln_traadv_muscl2,  &
          &                 ln_traadv_ubs  , ln_traadv_qck
       !!----------------------------------------------------------------------
@@ -156,5 +156,5 @@
          WRITE(numout,*) '      UBS    advection scheme        ln_traadv_ubs    = ', ln_traadv_ubs
          WRITE(numout,*) '      QUICKEST advection scheme      ln_traadv_qck    = ', ln_traadv_qck
-    ENDIF
+      ENDIF
 
       ioptio = 0                      ! Parameter control
@@ -168,7 +168,4 @@
 
       IF( ioptio /= 1 )   CALL ctl_stop( 'Choose ONE advection scheme in namelist namtra_adv' )
-
-      IF( n_cla == 1 .AND. .NOT. ln_traadv_cen2 )   &
-         &                CALL ctl_stop( 'cross-land advection only with 2nd order advection scheme' )
 
       !                              ! Set nadv
Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 2391)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 2392)
@@ -757,5 +757,5 @@
       END IF
 
-      IF( ( lk_trdmld ) .AND. ( n_cla == 1 ) ) THEN
+      IF( ( lk_trdmld ) .AND. ( nn_cla == 1 ) ) THEN
          WRITE(numout,cform_war)
          WRITE(numout,*) '                You set n_cla = 1. Note that the Mixed-Layer diagnostics  '
Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/cla.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/cla.F90	(revision 2391)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/cla.F90	(revision 2392)
@@ -1,59 +1,107 @@
 MODULE cla
-   !!==============================================================================
-   !!                         ***  MODULE  cla  ***
-   !! Cross Land Advection : parameterize ocean exchanges through straits by a
-   !!                        specified advection across land.
-   !!==============================================================================
+   !!======================================================================
+   !!                    ***  MODULE  cla  ***
+   !! Cross Land Advection : specific update of the horizontal divergence,
+   !!                        tracer trends and after velocity
+   !!
+   !!                 ---   Specific to ORCA_R2   ---
+   !!
+   !!======================================================================
+   !! History :  1.0  ! 2002-11 (A. Bozec)  Original code
+   !!            3.2  ! 2009-07 (G. Madec)  merge cla, cla_div, tra_cla, cla_dynspg
+   !!                 !                     and correct a mpp bug reported by A.R. Porter
+   !!----------------------------------------------------------------------
 #if defined key_orca_r2
    !!----------------------------------------------------------------------
-   !!   'key_orca_r2'   :                             ORCA R2 configuration
+   !!   'key_orca_r2'                                 global ocean model R2
    !!----------------------------------------------------------------------
-   !!   tra_cla           : update the tracer trend with the horizontal 
-   !!                       and vertical advection trends at straits
-   !!   tra_bab_el_mandeb : 
-   !!   tra_gibraltar     :
-   !!   tra_hormuz        :
-   !!   tra_cla_init      :
+   !!   cla_div           : update of horizontal divergence at cla straits
+   !!   tra_cla           : update of tracers at cla straits
+   !!   cla_dynspg        : update of after horizontal velocities at cla straits
+   !!   cla_init          : initialisation - control check
+   !!   cla_bab_el_mandeb : cross land advection for Bab-el-mandeb strait
+   !!   cla_gibraltar     : cross land advection for Gibraltar strait
+   !!   cla_hormuz        : cross land advection for Hormuz strait
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE oce             ! ocean dynamics and tracers variables
-   USE dom_oce         ! ocean space and time domain variables 
-   USE sbc_oce         ! surface boundary condition: ocean
-   USE in_out_manager  ! I/O manager
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE lib_mpp         ! distributed memory computing
+   USE oce            ! ocean dynamics and tracers
+   USE dom_oce        ! ocean space and time domain
+   USE sbc_oce        ! surface boundary condition: ocean
+   USE dynspg_oce     ! ocean dynamics: surface pressure gradient variables
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! distributed memory computing library
+   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
 
    IMPLICIT NONE
    PRIVATE
-
-   !! * Routine accessibility
-   PUBLIC tra_cla        ! routine called by step.F90
-   PUBLIC tra_cla_init   ! routine called by opa.F90
-
-   !! * Modules variables   
-   REAL(wp) :: zempmed, zempred
-
-   REAL(wp) :: zisw_rs, zurw_rs, zbrw_rs          ! Imposed transport Red Sea 
-   REAL(wp) :: zisw_ms, zmrw_ms, zurw_ms, zbrw_ms ! Imposed transport Med Sea 
-   REAL(wp) :: zisw_pg, zbrw_pg                   ! Imposed transport Persic Gulf 
-
-   REAL(wp), DIMENSION(jpk) ::   &
-      zu1_rs_i, zu2_rs_i, zu3_rs_i,              &  ! Red Sea velocities
-      zu1_ms_i, zu2_ms_i, zu3_ms_i,              &  ! Mediterranean Sea velocities
-      zu_pg                                         ! Persic Gulf velocities
-   REAL(wp), DIMENSION (jpk) :: zthor, zshor        ! Temperature, salinity Hormuz 
+   
+   PUBLIC   cla_init     ! routine called by opa.F90
+   PUBLIC   cla_div      ! routine called by divcur.F90
+   PUBLIC   cla_traadv   ! routine called by traadv.F90
+   PUBLIC   cla_dynspg   ! routine called by dynspg_flt.F90
+
+   INTEGER  ::   nbab, ngib, nhor   ! presence or not of required grid-point on local domain
+   !                                ! for Bab-el-Mandeb, Gibraltar, and Hormuz straits
+   
+   !                                                              !!! profile of hdiv for some straits
+   REAL(wp), DIMENSION (jpk) ::   hdiv_139_101, hdiv_139_101_kt    ! Gibraltar     strait, fixed & time evolving part (i,j)=(172,101)
+   REAL(wp), DIMENSION (jpk) ::   hdiv_139_102                     ! Gibraltar     strait, fixed part only            (i,j)=(139,102)
+   REAL(wp), DIMENSION (jpk) ::   hdiv_141_102, hdiv_141_102_kt    ! Gibraltar     strait, fixed & time evolving part (i,j)=(141,102)
+   REAL(wp), DIMENSION (jpk) ::   hdiv_161_88 , hdiv_161_88_kt     ! Bab-el-Mandeb strait, fixed & time evolving part (i,j)=(161,88)
+   REAL(wp), DIMENSION (jpk) ::   hdiv_161_87                      ! Bab-el-Mandeb strait, fixed part only            (i,j)=(161,87)
+   REAL(wp), DIMENSION (jpk) ::   hdiv_160_89 , hdiv_160_89_kt     ! Bab-el-Mandeb strait, fixed & time evolving part (i,j)=(160,89)
+   REAL(wp), DIMENSION (jpk) ::   hdiv_172_94                      ! Hormuz        strait, fixed part only            (i,j)=(172, 94)
+
+   REAL(wp), DIMENSION (jpk) ::   t_171_94_hor, s_171_94_hor       ! Temperature, salinity in the Hormuz strait
    
    !! * Substitutions
 #  include "domzgr_substitute.h90"
-#  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
-   SUBROUTINE tra_cla( kt )
+   SUBROUTINE cla_div( kt )
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE div_cla  ***
+      !!
+      !! ** Purpose :   update the horizontal divergence of the velocity field
+      !!              at some straits ( Gibraltar, Bab el Mandeb and Hormuz ).
+      !!
+      !! ** Method  : - first time-step: initialisation of cla
+      !!              - all   time-step: using imposed transport at each strait, 
+      !!              the now horizontal divergence is updated
+      !!
+      !! ** Action  :   phdivn   updted now horizontal divergence at cla straits
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
+      !!----------------------------------------------------------------------
+      !     
+      IF( kt == nit000 ) THEN
+         !
+         CALL cla_init                                        ! control check 
+         !
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'div_cla : cross land advection on hdiv '
+         IF(lwp) WRITE(numout,*) '~~~~~~~~'
+         !
+         IF( nbab == 1 )   CALL cla_bab_el_mandeb('ini')    ! Bab el Mandeb ( Red Sea - Indian ocean )
+         IF( ngib == 1 )   CALL cla_gibraltar    ('ini')    ! Gibraltar strait (Med Sea - Atlantic ocean)
+         IF( nhor == 1 )   CALL cla_hormuz       ('ini')    ! Hormuz Strait ( Persian Gulf - Indian ocean )
+         !
+      ENDIF                           
+      !
+      IF( nbab == 1    )   CALL cla_bab_el_mandeb('div')    ! Bab el Mandeb ( Red Sea - Indian ocean )
+      IF( ngib == 1    )   CALL cla_gibraltar    ('div')    ! Gibraltar strait (Med Sea - Atlantic ocean)
+      IF( nhor == 1    )   CALL cla_hormuz       ('div')    ! Hormuz Strait ( Persian Gulf - Indian ocean )
+      !
+!!gm  lbc useless here, no?
+!!gm      CALL lbc_lnk( hdivn, 'T', 1. )                    ! Lateral boundary conditions on hdivn
+      !
+   END SUBROUTINE cla_div
+   
+   
+   SUBROUTINE cla_traadv( kt )
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE tra_cla  ***
